searchNodes=[{"doc":"Background The community already has a lot of verification-related libraries, such as skooma, vex, but why write a new one? The api of vex is very much like Rails ActiveModel Validations, and it feels too complex for me, especially when it comes to customizing some validation modules, which is not convenient and flexible enough. Skooma, on the other hand, is very flexible and I find it particularly useful when validating non-map data structures. So the goal of this repository is: Support most of the types supported by the native sideway/joi Nested validation support. Easy internationalization Easy to extend Installation def deps do [ { :joi , &quot;~&gt; 0.2.0&quot; } , ] end Usage Joi validates data against a predefined schema with the Joi.validate/2 function. If the data is valid, the function returns {:ok, data} . The returned data will perform the transformation according to the provided schema. if the passed data does not match the type defined in the schema, the function returns {:error, errors} , the errors is a list of Joi.Error , that a struct contains four fields: context : map providing context of the error containing: key : key of the value that erred, equivalent to the last element of path. value : the value that failed validation. other error specific properties as described for each error code. message : string with a description of the error. path : list where each element is the accessor to the value where the error happened. type : type of the error. , When a field is received that is not specified in the provided schema, it does nothing and returns {:ok, data} . iex&gt; schema = %{ a : [ :integer ] } %{ a : [ :integer ] } iex&gt; data1 = %{ a : 1 } %{ a : 1 } iex&gt; Joi . validate ( data1 , schema ) { :ok , %{ a : 1 } } iex&gt; data2 = %{ a : &lt;&lt; 123 &gt;&gt; } iex&gt; Joi . validate ( data2 , schema ) { :error , [ % Joi.Error { context : %{ key : :a , value : &quot;{&quot; } , message : &quot;a must be a integer&quot; , path : [ :a ] , type : &quot;integer.base&quot; } ] } Supported Types atom boolean date datetime decimal float integer list map string Atom error types atom.base atom.inclusion Additional local context properties: %{ inclusion : list ( ) } atom.required Boolean error types boolean.base boolean.required Date error types date.base Examples: iex&gt; schema = %{ day : [ :date ] } %{ day : [ :date ] } iex&gt; Joi . validate ( %{ day : &quot;2021-07-20&quot; } , schema ) { :ok , %{ day : ~D[2021-07-20] } } iex&gt; Joi . validate ( %{ day : &quot;20210720&quot; } , schema ) { :error , [ % Joi.Error { context : %{ key : :day , value : &quot;20210720&quot; } , message : &quot;day must be a valid ISO-8601 date&quot; , path : [ :day ] , type : &quot;date.base&quot; } ] } date.required Datetime error types datetime.base Examples: iex&gt; schema = %{ day : [ :date ] } %{ day : [ :date ] } iex&gt; Joi . validate ( %{ day : &quot;2021-07-20&quot; } , schema ) { :ok , %{ day : ~D[2021-07-20] } } iex&gt; Joi . validate ( %{ day : &quot;20210720&quot; } , schema ) { :error , [ % Joi.Error { context : %{ key : :day , value : &quot;20210720&quot; } , message : &quot;day must be a valid ISO-8601 date&quot; , path : [ :day ] , type : &quot;date.base&quot; } ] } datetime.required Decimal error types decimal.base decimal.inclusion Additional local context properties: %{ inclusion : list ( ) } Examples: iex&gt; schema = %{ d : [ :decimal , inclusion : [ Decimal . new ( 1 ) ] ] } %{ d : [ :decimal , { :inclusion , [ Decimal . new ( 1 ) ] } ] } iex&gt; Joi . validate ( %{ d : Decimal . new ( 2 ) } , schema ) { :error , [ % Joi.Error { context : %{ inclusion : [ Decimal . new ( 1 ) ] , key : :d , value : Decimal . new ( 2 ) } , message : &quot;d must be one of \#{ inspect [ Decimal . new ( 1 ) ] } &quot; , path : [ :d ] , type : &quot;decimal.inclusion&quot; } ] } decimal.max Additional local context properties: %{ limit : float ( ) | integer ( ) | Decimal . t ( ) } Examples: iex&gt; schema = %{ n : [ :decimal , max : 1 ] } %{ n : [ :decimal , { :max , 1 } ] } iex&gt; Joi . validate ( %{ n : 0 } , schema ) { :ok , %{ n : Decimal . new ( 0 ) } } iex&gt; Joi . validate ( %{ n : &quot;2&quot; } , schema ) { :error , [ % Joi.Error { # string value will be converted to a float context : %{ key : :n , limit : Decimal . new ( 1 ) , value : Decimal . from_float ( 2.0 ) } , message : &quot;n must be less than or equal to 1&quot; , path : [ :n ] , type : &quot;decimal.max&quot; } ] } iex&gt; # max also support Decimal.t() iex&gt; schema = %{ n : [ :decimal , max : Decimal . new ( 1 ) ] } %{ n : [ :decimal , { :max , Decimal . new ( 1 ) } ] } iex&gt; Joi . validate ( %{ n : 2 } , schema ) { :error , [ % Joi.Error { context : %{ key : :n , limit : Decimal . new ( 1 ) , value : Decimal . new ( 2 ) } , message : &quot;n must be less than or equal to 1&quot; , path : [ :n ] , type : &quot;decimal.max&quot; } ] } iex&gt; # max also support float iex&gt; schema = %{ n : [ :decimal , max : 1.1 ] } %{ n : [ :decimal , { :max , 1.1 } ] } iex&gt; Joi . validate ( %{ n : 2 } , schema ) { :error , [ % Joi.Error { context : %{ key : :n , limit : Decimal . from_float ( 1.1 ) , value : Decimal . new ( 2 ) } , message : &quot;n must be less than or equal to 1.1&quot; , path : [ :n ] , type : &quot;decimal.max&quot; } ] } decimal.min Additional local context properties: %{ limit : float ( ) | integer ( ) } decimal.required Float error types float.base float.inclusion Additional local context properties: %{ inclusion : list ( ) } float.max Additional local context properties: %{ limit : float ( ) | integer ( ) } float.min Additional local context properties: %{ limit : float ( ) | integer ( ) } float.required Integer error types integer.base integer.inclusion Additional local context properties: %{ inclusion : list ( ) } integer.max Additional local context properties: %{ limit : integer ( ) } integer.min Additional local context properties: %{ limit : integer ( ) } integer.required List list supports some special features, such as validation for each element: iex&gt; schema = %{ l : [ :list , type : :integer ] } %{ l : [ :list , { :type , :integer } ] } iex&gt; Joi . validate ( %{ l : [ &lt;&lt; 123 &gt;&gt; ] } , schema ) { :error , [ % Joi.Error { context : %{ key : :l , value : [ &quot;{&quot; ] } , message : &quot;l must be a list of integer&quot; , path : [ :l ] , type : &quot;list.integer&quot; } ] } or a sub schema: iex&gt; sub_schema = %{ key : [ :integer ] } %{ key : [ :integer ] } iex&gt; schema = %{ l : [ :list , schema : sub_schema ] } %{ l : [ :list , { :schema , %{ key : [ :integer ] } } ] } iex&gt; Joi . validate ( %{ l : [ %{ key : 1 } , %{ key : &lt;&lt; 123 &gt;&gt; } ] } , schema ) { :error , [ % Joi.Error { context : %{ key : :key , value : &quot;{&quot; } , message : &quot;key must be a integer&quot; , path : [ :l , 1 , :key ] , type : &quot;integer.base&quot; } ] } error types list.base list.length Additional local context properties: %{ limit : integer ( ) } list.max_length Additional local context properties: %{ limit : integer ( ) } list.min_length Additional local context properties: %{ limit : integer ( ) } list.required list.schema list.type Map :map also supports validation with sub schema: iex&gt; sub_schema = %{ sub_key : [ :integer ] } %{ sub_key : [ :integer ] } iex&gt; schema = %{ m : [ :map , schema : sub_schema ] } %{ m : [ :map , { :schema , %{ sub_key : [ :integer ] } } ] } iex&gt; Joi . validate ( %{ m : %{ sub_key : &lt;&lt; 123 &gt;&gt; } } , schema ) { :error , [ % Joi.Error { context : %{ key : :sub_key , value : &quot;{&quot; } , message : &quot;sub_key must be a integer&quot; , path : [ :m , :sub_key ] , type : &quot;integer.base&quot; } ] } error types map.base map.required String error types string.base string.format string.inclusion Additional local context properties: %{ inclusion : list ( ) } string.length Additional local context properties: %{ limit : integer ( ) } string.max_length Additional local context properties: %{ limit : integer ( ) } string.min_length Additional local context properties: %{ limit : integer ( ) } string.required string.uuid Custom functions There is nothing magical about custom functions, you just need to return the same format as Joi's type, and then use :f as the key for the custom function in the schema, so you can use one or more custom functions inside a type. iex&gt; import Joi.Util iex&gt; func = fn field , data -&gt; ... &gt; case data [ field ] == 1 do ...&gt; true -&gt; { :ok , data } ...&gt; false -&gt; error ( &quot;custom&quot; , path : [ field ] , value : data [ field ] , message : &quot;does not match the custom function&quot; ) ...&gt; end ...&gt; end iex&gt; schema = %{ id : [ :integer , f : func ] } iex&gt; data = %{ id : 2 } iex&gt; Joi . validate ( data , schema ) { :error , [ % Joi.Error { context : %{ key : :id , message : &quot;does not match the custom function&quot; , value : 2 } , message : &quot;does not match the custom function&quot; , path : [ :id ] , type : &quot;custom&quot; } ] }","ref":"Joi.html","title":"Joi","type":"module"},{"doc":"Validate the data by schema Examples: iex&gt; schema = %{ ...&gt; id : [ :string , uuid : true ] , ...&gt; username : [ :string , min_length : 6 ] , ...&gt; pin : [ :integer , min : 1000 , max : 9999 ] , ...&gt; new_user : [ :boolean , truthy : [ &quot;1&quot; ] , falsy : [ &quot;0&quot; ] , required : false ] , ...&gt; account_ids : [ :list , type : :integer , max_length : 3 ] , ...&gt; remember_me : [ :boolean , required : false ] ...&gt; } %{ account_ids : [ :list , { :type , :integer } , { :max_length , 3 } ] , id : [ :string , { :uuid , true } ] , new_user : [ :boolean , { :truthy , [ &quot;1&quot; ] } , { :falsy , [ &quot;0&quot; ] } , { :required , false } ] , pin : [ :integer , { :min , 1000 } , { :max , 9999 } ] , remember_me : [ :boolean , { :required , false } ] , username : [ :string , { :min_length , 6 } ] } iex&gt; data = %{ id : &quot;c8ce4d74-fab8-44fc-90c2-736b8d27aa30&quot; , username : &quot;user@123&quot; , pin : 1234 , new_user : &quot;1&quot; , account_ids : [ 1 , 3 , 9 ] } %{ account_ids : [ 1 , 3 , 9 ] , id : &quot;c8ce4d74-fab8-44fc-90c2-736b8d27aa30&quot; , new_user : &quot;1&quot; , pin : 1234 , username : &quot;user@123&quot; } iex&gt; Joi . validate ( data , schema ) { :ok , %{ account_ids : [ 1 , 3 , 9 ] , id : &quot;c8ce4d74-fab8-44fc-90c2-736b8d27aa30&quot; , new_user : true , pin : 1234 , username : &quot;user@123&quot; } } iex&gt; error_data = %{ id : &quot;1&quot; , username : &quot;user&quot; , pin : 999 , new_user : 1 , account_ids : [ 1 , 3 , 9 , 12 ] } %{ account_ids : [ 1 , 3 , 9 , 12 ] , id : &quot;1&quot; , new_user : 1 , pin : 999 , username : &quot;user&quot; } iex&gt; Joi . validate ( error_data , schema ) { :error , [ % Joi.Error { context : %{ key : :username , limit : 6 , value : &quot;user&quot; } , message : &quot;username length must be at least 6 characters long&quot; , path : [ :username ] , type : &quot;string.min_length&quot; } , % Joi.Error { context : %{ key : :pin , limit : 1000 , value : 999 } , message : &quot;pin must be greater than or equal to 1000&quot; , path : [ :pin ] , type : &quot;integer.min&quot; } , % Joi.Error { context : %{ key : :new_user , value : 1 } , message : &quot;new_user must be a boolean&quot; , path : [ :new_user ] , type : &quot;boolean.base&quot; } , % Joi.Error { context : %{ key : :id , value : &quot;1&quot; } , message : &quot;id must be a uuid&quot; , path : [ :id ] , type : &quot;string.uuid&quot; } , % Joi.Error { context : %{ key : :account_ids , limit : 3 , value : [ 1 , 3 , 9 , 12 ] } , message : &quot;account_ids must contain less than or equal to 3 items&quot; , path : [ :account_ids ] , type : &quot;list.max_length&quot; } ] }","ref":"Joi.html#validate/2","title":"Joi.validate/2","type":"function"},{"doc":"","ref":"Joi.Error.html","title":"Joi.Error","type":"module"},{"doc":"The struct of error","ref":"Joi.Error.html#__struct__/0","title":"Joi.Error.__struct__/0","type":"function"},{"doc":"","ref":"Joi.Error.html#new/2","title":"Joi.Error.new/2","type":"function"},{"doc":"","ref":"Joi.Error.html#t:t/0","title":"Joi.Error.t/0","type":"type"},{"doc":"","ref":"Joi.Type.Date.html","title":"Joi.Type.Date","type":"module"},{"doc":"","ref":"Joi.Type.Date.html#convert/3","title":"Joi.Type.Date.convert/3","type":"function"},{"doc":"","ref":"Joi.Type.Date.html#message/2","title":"Joi.Type.Date.message/2","type":"function"},{"doc":"","ref":"Joi.Type.Date.html#message_map/1","title":"Joi.Type.Date.message_map/1","type":"function"},{"doc":"","ref":"Joi.Type.Date.html#validate_field/3","title":"Joi.Type.Date.validate_field/3","type":"function"},{"doc":"","ref":"Joi.Type.Decimal.html","title":"Joi.Type.Decimal","type":"module"},{"doc":"","ref":"Joi.Type.Decimal.html#convert/3","title":"Joi.Type.Decimal.convert/3","type":"function"},{"doc":"","ref":"Joi.Type.Decimal.html#message/2","title":"Joi.Type.Decimal.message/2","type":"function"},{"doc":"","ref":"Joi.Type.Decimal.html#message_map/1","title":"Joi.Type.Decimal.message_map/1","type":"function"},{"doc":"","ref":"Joi.Type.Decimal.html#validate_field/3","title":"Joi.Type.Decimal.validate_field/3","type":"function"},{"doc":"","ref":"Joi.Type.Float.html","title":"Joi.Type.Float","type":"module"},{"doc":"","ref":"Joi.Type.Float.html#message/2","title":"Joi.Type.Float.message/2","type":"function"},{"doc":"","ref":"Joi.Type.Float.html#message_map/1","title":"Joi.Type.Float.message_map/1","type":"function"},{"doc":"","ref":"Joi.Type.Float.html#validate_field/3","title":"Joi.Type.Float.validate_field/3","type":"function"},{"doc":"","ref":"Joi.Type.Integer.html","title":"Joi.Type.Integer","type":"module"},{"doc":"","ref":"Joi.Type.Integer.html#message/2","title":"Joi.Type.Integer.message/2","type":"function"},{"doc":"","ref":"Joi.Type.Integer.html#message_map/1","title":"Joi.Type.Integer.message_map/1","type":"function"},{"doc":"Returns a integer when input a integer string or float string, others, Returns nil Examples: iex&gt; string_to_integer(&quot;1&quot;) 1 iex&gt; string_to_integer(&quot;01&quot;) 1 iex&gt; string_to_integer(&quot;01k&quot;) nil iex&gt; string_to_integer(&quot;1k&quot;) nil iex&gt; string_to_integer(&quot;1.1&quot;) 1 iex&gt; string_to_integer(&quot;1.1k&quot;) nil","ref":"Joi.Type.Integer.html#string_to_integer/1","title":"Joi.Type.Integer.string_to_integer/1","type":"function"},{"doc":"","ref":"Joi.Type.Integer.html#validate_field/3","title":"Joi.Type.Integer.validate_field/3","type":"function"},{"doc":"","ref":"Joi.Type.Map.html","title":"Joi.Type.Map","type":"module"},{"doc":"","ref":"Joi.Type.Map.html#message/2","title":"Joi.Type.Map.message/2","type":"function"},{"doc":"","ref":"Joi.Type.Map.html#message_map/1","title":"Joi.Type.Map.message_map/1","type":"function"},{"doc":"","ref":"Joi.Type.Map.html#validate_by_field_schema/3","title":"Joi.Type.Map.validate_by_field_schema/3","type":"function"},{"doc":"","ref":"Joi.Type.Map.html#validate_field/3","title":"Joi.Type.Map.validate_field/3","type":"function"},{"doc":"","ref":"Joi.Util.html","title":"Joi.Util","type":"module"},{"doc":"Returns all types that Joi supported","ref":"Joi.Util.html#all_types/0","title":"Joi.Util.all_types/0","type":"function"},{"doc":"Append a parent_path to the options of schema's field","ref":"Joi.Util.html#append_parent_path_to/2","title":"Joi.Util.append_parent_path_to/2","type":"function"},{"doc":"Return a module name when input a atom Examples: iex&gt; atom_type_to_mod ( :atom ) Joi.Type.Atom","ref":"Joi.Util.html#atom_type_to_mod/1","title":"Joi.Util.atom_type_to_mod/1","type":"function"},{"doc":"See Joi.Error.new/2 .","ref":"Joi.Util.html#error/2","title":"Joi.Util.error/2","type":"function"},{"doc":"","ref":"Joi.Util.html#is_schema/1","title":"Joi.Util.is_schema/1","type":"function"},{"doc":"","ref":"Joi.Util.html#len/1","title":"Joi.Util.len/1","type":"function"},{"doc":"Return a new parent path. The parent path default is nil, the return a [parent_index] list by input field.","ref":"Joi.Util.html#parent_path/2","title":"Joi.Util.parent_path/2","type":"function"},{"doc":"Return the real path of error Examples: iex&gt; path ( &quot;2&quot; , parent_path : [ 1 ] ) [ 1 , &quot;2&quot; ] iex&gt; path ( &quot;2&quot; , [ ] ) [ &quot;2&quot; ]","ref":"Joi.Util.html#path/2","title":"Joi.Util.path/2","type":"function"},{"doc":"","ref":"Joi.Util.html#string_to_float/1","title":"Joi.Util.string_to_float/1","type":"function"},{"doc":"Returns a list of types that support the input validator Examples: iex&gt; types_of ( :min_length ) [ :string , atom , :list ]","ref":"Joi.Util.html#types_by/1","title":"Joi.Util.types_by/1","type":"function"},{"doc":"","ref":"Joi.Validator.Custom.html","title":"Joi.Validator.Custom","type":"module"},{"doc":"","ref":"Joi.Validator.Custom.html#validate_field/3","title":"Joi.Validator.Custom.validate_field/3","type":"function"},{"doc":"","ref":"Joi.Validator.Inclusion.html","title":"Joi.Validator.Inclusion","type":"module"},{"doc":"","ref":"Joi.Validator.Inclusion.html#inclusion_validate/4","title":"Joi.Validator.Inclusion.inclusion_validate/4","type":"function"},{"doc":"","ref":"Joi.Validator.Length.html","title":"Joi.Validator.Length","type":"module"},{"doc":"","ref":"Joi.Validator.Length.html#length_validate/4","title":"Joi.Validator.Length.length_validate/4","type":"function"},{"doc":"","ref":"Joi.Validator.Max.html","title":"Joi.Validator.Max","type":"module"},{"doc":"","ref":"Joi.Validator.Max.html#max_validate/4","title":"Joi.Validator.Max.max_validate/4","type":"function"},{"doc":"","ref":"Joi.Validator.Max.html#to_decimal/1","title":"Joi.Validator.Max.to_decimal/1","type":"function"},{"doc":"","ref":"Joi.Validator.MaxLength.html","title":"Joi.Validator.MaxLength","type":"module"},{"doc":"","ref":"Joi.Validator.MaxLength.html#max_length_validate/4","title":"Joi.Validator.MaxLength.max_length_validate/4","type":"function"},{"doc":"","ref":"Joi.Validator.Min.html","title":"Joi.Validator.Min","type":"module"},{"doc":"","ref":"Joi.Validator.Min.html#min_validate/4","title":"Joi.Validator.Min.min_validate/4","type":"function"},{"doc":"","ref":"Joi.Validator.MinLength.html","title":"Joi.Validator.MinLength","type":"module"},{"doc":"","ref":"Joi.Validator.MinLength.html#min_length_validate/4","title":"Joi.Validator.MinLength.min_length_validate/4","type":"function"},{"doc":"","ref":"Joi.Validator.Skipping.html","title":"Joi.Validator.Skipping","type":"module"},{"doc":"","ref":"Joi.Validator.Skipping.html#skip?/1","title":"Joi.Validator.Skipping.skip?/1","type":"function"},{"doc":"","ref":"Joi.Validator.Skipping.html#unless_field_not_nil/2","title":"Joi.Validator.Skipping.unless_field_not_nil/2","type":"function"},{"doc":"When [required: false] and params[field] == nil, skip validating.","ref":"Joi.Validator.Skipping.html#unless_skipping/5","title":"Joi.Validator.Skipping.unless_skipping/5","type":"macro"},{"doc":"Joi This project is inspired by sideway/joi and lob/litmus . And the code of this repository is based on lob/litmus , but the API of this repository is completely different from litmus.","ref":"readme.html","title":"Joi","type":"extras"},{"doc":"The community already has a lot of verification-related libraries, such as skooma, vex, but why write a new one? The api of vex is very much like Rails ActiveModel Validations, and it feels too complex for me, especially when it comes to customizing some validation modules, which is not convenient and flexible enough. Skooma, on the other hand, is very flexible and I find it particularly useful when validating non-map data structures. So the goal of this repository is: Support most of the types supported by the native sideway/joi Nested validation support. Easy internationalization Easy to extend","ref":"readme.html#background","title":"Joi - Background","type":"extras"},{"doc":"def deps do [ { :joi , &quot;~&gt; 0.2.0&quot; } , ] end","ref":"readme.html#installation","title":"Joi - Installation","type":"extras"},{"doc":"Joi validates data against a predefined schema with the Joi.validate/2 function. If the data is valid, the function returns {:ok, data} . The returned data will perform the transformation according to the provided schema. if the passed data does not match the type defined in the schema, the function returns {:error, errors} , the errors is a list of Joi.Error , that a struct contains four fields: context : map providing context of the error containing: key : key of the value that erred, equivalent to the last element of path. value : the value that failed validation. other error specific properties as described for each error code. message : string with a description of the error. path : list where each element is the accessor to the value where the error happened. type : type of the error. , When a field is received that is not specified in the provided schema, it does nothing and returns {:ok, data} . iex&gt; schema = %{ a : [ :integer ] } %{ a : [ :integer ] } iex&gt; data1 = %{ a : 1 } %{ a : 1 } iex&gt; Joi . validate ( data1 , schema ) { :ok , %{ a : 1 } } iex&gt; data2 = %{ a : &lt;&lt; 123 &gt;&gt; } iex&gt; Joi . validate ( data2 , schema ) { :error , [ % Joi.Error { context : %{ key : :a , value : &quot;{&quot; } , message : &quot;a must be a integer&quot; , path : [ :a ] , type : &quot;integer.base&quot; } ] } Supported Types atom boolean date datetime decimal float integer list map string Atom error types atom.base atom.inclusion Additional local context properties: %{ inclusion : list ( ) } atom.required Boolean error types boolean.base boolean.required Date error types date.base Examples: iex&gt; schema = %{ day : [ :date ] } %{ day : [ :date ] } iex&gt; Joi . validate ( %{ day : &quot;2021-07-20&quot; } , schema ) { :ok , %{ day : ~D[2021-07-20] } } iex&gt; Joi . validate ( %{ day : &quot;20210720&quot; } , schema ) { :error , [ % Joi.Error { context : %{ key : :day , value : &quot;20210720&quot; } , message : &quot;day must be a valid ISO-8601 date&quot; , path : [ :day ] , type : &quot;date.base&quot; } ] } date.required Datetime error types datetime.base Examples: iex&gt; schema = %{ day : [ :date ] } %{ day : [ :date ] } iex&gt; Joi . validate ( %{ day : &quot;2021-07-20&quot; } , schema ) { :ok , %{ day : ~D[2021-07-20] } } iex&gt; Joi . validate ( %{ day : &quot;20210720&quot; } , schema ) { :error , [ % Joi.Error { context : %{ key : :day , value : &quot;20210720&quot; } , message : &quot;day must be a valid ISO-8601 date&quot; , path : [ :day ] , type : &quot;date.base&quot; } ] } datetime.required Decimal error types decimal.base decimal.inclusion Additional local context properties: %{ inclusion : list ( ) } Examples: iex&gt; schema = %{ d : [ :decimal , inclusion : [ Decimal . new ( 1 ) ] ] } %{ d : [ :decimal , { :inclusion , [ Decimal . new ( 1 ) ] } ] } iex&gt; Joi . validate ( %{ d : Decimal . new ( 2 ) } , schema ) { :error , [ % Joi.Error { context : %{ inclusion : [ Decimal . new ( 1 ) ] , key : :d , value : Decimal . new ( 2 ) } , message : &quot;d must be one of \#{ inspect [ Decimal . new ( 1 ) ] } &quot; , path : [ :d ] , type : &quot;decimal.inclusion&quot; } ] } decimal.max Additional local context properties: %{ limit : float ( ) | integer ( ) | Decimal . t ( ) } Examples: iex&gt; schema = %{ n : [ :decimal , max : 1 ] } %{ n : [ :decimal , { :max , 1 } ] } iex&gt; Joi . validate ( %{ n : 0 } , schema ) { :ok , %{ n : Decimal . new ( 0 ) } } iex&gt; Joi . validate ( %{ n : &quot;2&quot; } , schema ) { :error , [ % Joi.Error { # string value will be converted to a float context : %{ key : :n , limit : Decimal . new ( 1 ) , value : Decimal . from_float ( 2.0 ) } , message : &quot;n must be less than or equal to 1&quot; , path : [ :n ] , type : &quot;decimal.max&quot; } ] } iex&gt; # max also support Decimal.t() iex&gt; schema = %{ n : [ :decimal , max : Decimal . new ( 1 ) ] } %{ n : [ :decimal , { :max , Decimal . new ( 1 ) } ] } iex&gt; Joi . validate ( %{ n : 2 } , schema ) { :error , [ % Joi.Error { context : %{ key : :n , limit : Decimal . new ( 1 ) , value : Decimal . new ( 2 ) } , message : &quot;n must be less than or equal to 1&quot; , path : [ :n ] , type : &quot;decimal.max&quot; } ] } iex&gt; # max also support float iex&gt; schema = %{ n : [ :decimal , max : 1.1 ] } %{ n : [ :decimal , { :max , 1.1 } ] } iex&gt; Joi . validate ( %{ n : 2 } , schema ) { :error , [ % Joi.Error { context : %{ key : :n , limit : Decimal . from_float ( 1.1 ) , value : Decimal . new ( 2 ) } , message : &quot;n must be less than or equal to 1.1&quot; , path : [ :n ] , type : &quot;decimal.max&quot; } ] } decimal.min Additional local context properties: %{ limit : float ( ) | integer ( ) } decimal.required Float error types float.base float.inclusion Additional local context properties: %{ inclusion : list ( ) } float.max Additional local context properties: %{ limit : float ( ) | integer ( ) } float.min Additional local context properties: %{ limit : float ( ) | integer ( ) } float.required Integer error types integer.base integer.inclusion Additional local context properties: %{ inclusion : list ( ) } integer.max Additional local context properties: %{ limit : integer ( ) } integer.min Additional local context properties: %{ limit : integer ( ) } integer.required List list supports some special features, such as validation for each element: iex&gt; schema = %{ l : [ :list , type : :integer ] } %{ l : [ :list , { :type , :integer } ] } iex&gt; Joi . validate ( %{ l : [ &lt;&lt; 123 &gt;&gt; ] } , schema ) { :error , [ % Joi.Error { context : %{ key : :l , value : [ &quot;{&quot; ] } , message : &quot;l must be a list of integer&quot; , path : [ :l ] , type : &quot;list.integer&quot; } ] } or a sub schema: iex&gt; sub_schema = %{ key : [ :integer ] } %{ key : [ :integer ] } iex&gt; schema = %{ l : [ :list , schema : sub_schema ] } %{ l : [ :list , { :schema , %{ key : [ :integer ] } } ] } iex&gt; Joi . validate ( %{ l : [ %{ key : 1 } , %{ key : &lt;&lt; 123 &gt;&gt; } ] } , schema ) { :error , [ % Joi.Error { context : %{ key : :key , value : &quot;{&quot; } , message : &quot;key must be a integer&quot; , path : [ :l , 1 , :key ] , type : &quot;integer.base&quot; } ] } error types list.base list.length Additional local context properties: %{ limit : integer ( ) } list.max_length Additional local context properties: %{ limit : integer ( ) } list.min_length Additional local context properties: %{ limit : integer ( ) } list.required list.schema list.type Map :map also supports validation with sub schema: iex&gt; sub_schema = %{ sub_key : [ :integer ] } %{ sub_key : [ :integer ] } iex&gt; schema = %{ m : [ :map , schema : sub_schema ] } %{ m : [ :map , { :schema , %{ sub_key : [ :integer ] } } ] } iex&gt; Joi . validate ( %{ m : %{ sub_key : &lt;&lt; 123 &gt;&gt; } } , schema ) { :error , [ % Joi.Error { context : %{ key : :sub_key , value : &quot;{&quot; } , message : &quot;sub_key must be a integer&quot; , path : [ :m , :sub_key ] , type : &quot;integer.base&quot; } ] } error types map.base map.required String error types string.base string.format string.inclusion Additional local context properties: %{ inclusion : list ( ) } string.length Additional local context properties: %{ limit : integer ( ) } string.max_length Additional local context properties: %{ limit : integer ( ) } string.min_length Additional local context properties: %{ limit : integer ( ) } string.required string.uuid Custom functions There is nothing magical about custom functions, you just need to return the same format as Joi's type, and then use :f as the key for the custom function in the schema, so you can use one or more custom functions inside a type. iex&gt; import Joi.Util iex&gt; func = fn field , data -&gt; ... &gt; case data [ field ] == 1 do ...&gt; true -&gt; { :ok , data } ...&gt; false -&gt; error ( &quot;custom&quot; , path : [ field ] , value : data [ field ] , message : &quot;does not match the custom function&quot; ) ...&gt; end ...&gt; end iex&gt; schema = %{ id : [ :integer , f : func ] } iex&gt; data = %{ id : 2 } iex&gt; Joi . validate ( data , schema ) { :error , [ % Joi.Error { context : %{ key : :id , message : &quot;does not match the custom function&quot; , value : 2 } , message : &quot;does not match the custom function&quot; , path : [ :id ] , type : &quot;custom&quot; } ] }","ref":"readme.html#usage","title":"Joi - Usage","type":"extras"},{"doc":"Feel free to dive in! Open an issue or submit PRS. Joi follows the Contributor Covenant Code of Conduct.","ref":"readme.html#contributing","title":"Joi - Contributing","type":"extras"}]